package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import flashx.textLayout.formats.BackgroundColor;
	import flashx.textLayout.operations.RedoOperation;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		public var game:Game;
		public var bg:FlxGroup;
		public var grp:FlxGroup;
		public var draggingrect:Boolean=false;
		public var candrect:Array=[0,0,1,1];
		public var candrect_rect:Array=[0,0,1,1];
		public var validrect:Boolean=false;
		public var rectspr:FlxSprite;
		public var squarehighlight:FlxSprite;
		public var dragdeleting:Boolean;
		
		override public function create():void
		{
			bgColor=0xffffffaa;
			game = new Game();
			bg = new FlxGroup();
			add(bg);
			grp = new FlxGroup();
			bg.add(grp);
			squarehighlight = new FlxSprite(0,0);
			//squarehighlight.alpha=0.5;
			squarehighlight.createGraphic(Game.cellsize-1,Game.cellsize-1,0x88ffffff);
			add(squarehighlight);
			rectspr = new FlxSprite(0,0);
			rectspr.visible=false;
			rectspr.createGraphic(Game.cellsize,Game.cellsize,0x88ffffff);
			//rectspr.color=0xffff00;
			add(rectspr);
			DrawGame();
		}
		
		public function DrawGame():void
		{
			bg.remove(grp,true);
			grp = game.Draw();
			bg.add(grp);
		}
		
		public function MouseToCoord():Array
		{
			var result	:Array=[-1,-1];
			var mx:int=FlxG.mouse.x;
			var my:int=FlxG.mouse.y;			
			mx-=Game.margin+2*Game.cellsize;
			my-=Game.margin+2*Game.cellsize;
			if (mx<0 || my<0)
			{
				mx=-100;
			}
			mx/=Game.cellsize;
			my/=Game.cellsize;
			if (mx>=0&&mx<Game.width &&my>=0&&my<Game.width)
			{
				result=[mx,my];
			}
			return result;
		}
		
		private function RectRect():void
		{
			
			if (candrect[2]<=0)
			{
				candrect_rect[0]=candrect[0]-1+candrect[2];
				candrect_rect[2]=-candrect[2]+2;					
			}
			else
			{
				candrect_rect[0]=candrect[0];
				candrect_rect[2]=candrect[2];
			}
			
			if (candrect[3]<=0)
			{
				candrect_rect[1]=candrect[1]-1+candrect[3];
				candrect_rect[3]=-candrect[3]+2;					
			}
			else
			{
				candrect_rect[1]=candrect[1];
				candrect_rect[3]=candrect[3];
			}
		}
		
		public function SetRectSpr():void
		{
			if (draggingrect)
			{
				RectRect();
				rectspr.x = Game.margin+(candrect_rect[0]+2)*Game.cellsize+3;
				rectspr.y = Game.margin+(candrect_rect[1]+2)*Game.cellsize+3;
				rectspr.createGraphic(candrect_rect[2]*Game.cellsize-5,candrect_rect[3]*Game.cellsize-5,0x88ffffff);				
				rectspr.visible=true;	
				if (validrect)
				{
					rectspr.color=0xffffff;
				}
				else
				{
					rectspr.color=0xff0000;
				}
			}
			else
			{
				rectspr.visible=false;
			}
		}
		override public function update():void
		{
			super.update();
			
			if (game.won)
			{
				if (FlxG.mouse.justPressed())
				{
					FlxG.level++;
					if (FlxG.level>=Game.levels.length)
					{
						FlxG.state = new EndState();
					}
					else
					{
						FlxG.state = new GameState();						
					}
				}				
				return;
			}
			
			var mpos:Array = MouseToCoord();
			if (mpos[0]!=-1)
			{
				squarehighlight.x=Game.margin+(mpos[0]+2)*Game.cellsize+1;
				squarehighlight.y=Game.margin+(mpos[1]+2)*Game.cellsize+1;
				squarehighlight.visible=true;
			}
			else
			{
				squarehighlight.visible=false;
			}			
			
			if (draggingrect==false && FlxG.mouse.justPressed() && mpos[0]!=-1)
			{			
				if (game.Occupied(mpos[0],mpos[1]))
				{
					//remove rect
					game=game.RemoveRect(mpos[0],mpos[1]);
					dragdeleting=true;
					//trace("removing"+mpos[0]+","+mpos[1]+","+game.rects.length);
					DrawGame();
				}
				else
				{
					draggingrect=true;
					candrect[0]=mpos[0];
					candrect[1]=mpos[1];
					candrect[2]=1;
					candrect[3]=1;				
					SetRectSpr();
				}
			}
			if (FlxG.mouse.pressed())
			{
				if (draggingrect)
				{
					if (mpos[0]==-1)
					{
						validrect=false;
						SetRectSpr();
					}
					else
					{
						candrect[2]=mpos[0]-candrect[0]+1;
						candrect[3]=mpos[1]-candrect[1]+1;
						RectRect();
						if (game.CanAddRect(candrect_rect))
						{
							validrect=true;
						}
						else
						{
							validrect=false;
						}
						SetRectSpr();
					}
				}
				if(dragdeleting && mpos[0]!=-1)
				{
					if (game.Occupied(mpos[0],mpos[1]))
					{
						game=game.RemoveRect(mpos[0],mpos[1]);
						dragdeleting=true;
						//trace("removing"+mpos[0]+","+mpos[1]+","+game.rects.length);
						DrawGame();
					}
					
				}
			}
			else
			{
				rectspr.visible=false;
			}
			
			if (FlxG.mouse.justReleased())
			{
				if (draggingrect)
				{
					if (validrect)
					{
						RectRect();
						game = game.AddRect(candrect_rect);
						DrawGame();
					}
					draggingrect=false;
					SetRectSpr();
				}
				dragdeleting=false;
			}
			//rectspr.visible=draggingrect;
			
		}
	}
}